'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _leaf = require('./leaf');

var _leaf2 = _interopRequireDefault(_leaf);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Text.
 */

var Text = function (_React$Component) {
  _inherits(Text, _React$Component);

  function Text() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Text);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Text)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.render = function () {
      var node = _this.props.node;

      return _react2.default.createElement(
        'span',
        { 'data-key': node.key },
        _this.renderLeaves()
      );
    }, _this.renderLeaves = function () {
      var _this$props = _this.props;
      var node = _this$props.node;
      var block = _this$props.block;
      var renderDecorations = _this$props.renderDecorations;

      var ranges = node.getDecoratedRanges(block, renderDecorations);

      return ranges.map(function (range, i, original) {
        var previous = original.slice(0, i);
        var offset = previous.size ? previous.map(function (r) {
          return r.text;
        }).join('').length : 0;
        return _this.renderLeaf(ranges, range, i, offset);
      });
    }, _this.renderLeaf = function (ranges, range, index, offset) {
      var _this$props2 = _this.props;
      var node = _this$props2.node;
      var renderMark = _this$props2.renderMark;
      var state = _this$props2.state;

      var text = range.text;
      var marks = range.marks;

      return _react2.default.createElement(_leaf2.default, {
        key: node.key + '-' + index,
        index: index,
        state: state,
        node: node,
        text: text,
        marks: marks,
        ranges: ranges,
        renderMark: renderMark
      });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  /**
   * Properties.
   */

  /**
   * Render.
   *
   * @return {Element} element
   */

  /**
   * Render the leaf nodes.
   *
   * @return {Array} leaves
   */

  /**
   * Render a single leaf node given a `range` and `offset`.
   *
   * @param {List} ranges
   * @param {Range} range
   * @param {Number} index
   * @param {Number} offset
   * @return {Element} leaf
   */

  return Text;
}(_react2.default.Component);

/**
 * Export.
 */

Text.propTypes = {
  editor: _react2.default.PropTypes.object.isRequired,
  node: _react2.default.PropTypes.object.isRequired,
  renderDecorations: _react2.default.PropTypes.func.isRequired,
  renderMark: _react2.default.PropTypes.func.isRequired,
  state: _react2.default.PropTypes.object.isRequired
};
exports.default = Text;