'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

/**
 * Check whether a `dataTransfer` object is a file transfer.
 *
 * @param  {Object} ev event
 * @return {Boolean} true if dataTransfer has files in its type property
 */

function dataTransferIsFiles(event) {
  var types = event.dataTransfer.types;
  var is = types.contains ? types.contains('Files') : types.indexOf('Files') !== -1;
  return is;
}

/**
 * Export.
 *
 * @type {Function}
 */

exports.default = dataTransferIsFiles;