'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

/**
 * Check whether a `dataTransfer` object is a file transfer.
 *
 * @param {DataTransfer} dataTransfer
 * @return {Boolean}
 */

function isFileDataTransfer(dataTransfer) {
  var types = dataTransfer.types;
  var is = types.contains ? types.contains('Files') : types.indexOf('Files') !== -1;
  return is;
}

/**
 * Export.
 *
 * @type {Function}
 */

exports.default = isFileDataTransfer;